#ifndef	lint
static char sccsid[] = "@(#)filedump.c 11/20/92 1.1 11/20/92 (c) SyddWare";
#endif
/*#*************************************************************************#*/
/*#                                                                         #*/
/*#                            (c) 1988 SyddWare                            #*/
/*#	                                                                        #*/
/*#*************************************************************************#*/
/*#	                                                                        #*/
/*#  Module Name:   EXECUTABLE                 Version:  1.0                #*/
/*#	                                                                        #*/
/*#  Program Name:                             filedump                     #*/
/*#	                                                                        #*/
/*#  Programmer:                               Jeffrey R. Souza             #*/
/*#	                                                                        #*/
/*#  Date:                                     1 April 1988                 #*/
/*#	                                                                        #*/
/*#  Revision Log                                                           #*/
/*#	                                                                        #*/
/*#   Date    Description                                               RI  #*/
/*# --------  -------------------------------------------------------- ---- #*/
/*#	                                                                        #*/
/*#*************************************************************************#*/
/*#	                                                                        #*/
/*#  Purpose: Dumps contents of a file in HEX and ASCII.                    #*/
/*#	                                                                        #*/
/*#  Calling Sequence:	filedump input_filename                             #*/
/*#	                                                                        #*/
/*#  Arguments:                                                             #*/
/*#  Name             Type     I/O  Description                             #*/
/*#  ---------------  -------  ---  --------------------------------------  #*/
/*#  input_filename   char *	I   Name of file to be dumped.              #*/
/*#	                                                                        #*/
/*#  I/O Files And Tables:  none                                            #*/
/*#	                                                                        #*/
/*#  Called By: DOS command                                                 #*/
/*#	                                                                        #*/
/*#  Calls to NonStandard Routines: None                                    #*/
/*#	                                                                        #*/
/*#  Calls To Operating System:  fopen(), fgetc(), fprintf(), fclose()      #*/
/*#	                                                                        #*/
/*#  Restrictions:                                                          #*/
/*#	                                                                        #*/
/*#  Notes:                                                                 #*/
/*#	                                                                        #*/
/*#*************************************************************************#*/
#include <stdio.h>
#include <errno.h>

main(argc,argv)
   char    *argv[];
   int	   argc;
{
	 FILE	*fi = (FILE *)0;

	int	icnt,jcnt;
	int	buffer;
	char	save[16];
	long	offset;

/*
   initialize values and open files
*/
   fprintf(stdout,"ASCII File Dump V1.0 (c) 1988 SyddWare\n");

	if (argc < 2 || !strcmp(argv[1],"-"))
		fi = stdin;
   if (fi || (fi = fopen(argv[1],"rb")))
   {
   	fprintf(stdout,"Offset   Hex                                           \
   ASCII\n");
   	fprintf(stdout,"-------- ----------------------------------------------\
-  ----------------\n");
	   offset = 0l;
       buffer = getc(fi);
       while (buffer != EOF)
       {
	   fprintf(stdout,"%08lX ",offset);
	   for (jcnt=0;jcnt<16 && buffer != EOF;++jcnt)
	   {
	       save[jcnt] = buffer;
	       fprintf(stdout,"%02X ",buffer);
	       buffer = getc(fi);
		++offset;
	   }
	   icnt = jcnt;
	   for (jcnt=icnt;jcnt<16;++jcnt)
	       fprintf(stdout,"   ");
	   fprintf(stdout," ");
	   for (jcnt=0;jcnt<icnt;++jcnt)
	   {
	       if (save[jcnt] > 31 && save[jcnt] < 127)
		   fprintf(stdout,"%1.1c",save[jcnt]);
	       else
		   fprintf(stdout,".");
	   }
	   fprintf(stdout,"\n");
       }
       fprintf(stdout,"\nDumped %ld (0x%lx) bytes of file %s\n",offset,offset,
		(fi == stdin)?"stdin":argv[1]);
       if (fi != stdin) fclose(fi);
   }
   else
   {
       fprintf(stderr,"FILEDUMP: Error opening file %s for read.\n",
	   		argv[1]);
       fprintf(stdout,"%s\n",argv[0]);
       fprintf(stdout,"\
NAME\n\
    filedump -	   dumps the contents of any file in hex & ascii\n\
\n\
SYNOPSIS\n\
     filedump [input_file|-]\n\
\n\
DESCRIPTION\n\
     This routine dumps a hex and ASCII listing of any input_file on your \n\
     system.  It displays the hex bytes in sets of 16 and displays any \n\
     ASCII printable characters in their readable form.  All unprintable \n\
     bytes are replaced by a period (.) in the ASCII display.  The format is\n\
     the same as that used in the dump() debugging subroutine.  This\n\
     routine is useful for spotting text in object and executables and as a\n\
     possible aid to finding Trojan Horses by using it to spot %cHa Ha we got\n\
     you%c type messages.\n\
\n\
FILES\n\
     Output is to the screen, input may be read from an optionally \n\
     specified file. \n\
\n\
SEE ALSO\n\
     dump()\n", 0x22, 0x22);
       exit(0);
   }
leave:;
}
